from ZODB.POSException import ConflictError

def makeFile(context, file_file):
  file = file_file

  if file is None:
    return
		
  id = context.generateUniqueId('File')
    
  #file validate script stuff
  size = 0

  if file is None:
    filename=None
  else:
    filename=getattr(file, 'filename', None)
	
  if hasattr(context, 'get_size'):  # make sure things work with portal_factory
    size=context.get_size()

  if not filename and not size:
    state.setError('file', 'You must upload a file')

  if context.CreationDate() == context.ModificationDate() and filename:
    alternative_id = filename[max( string.rfind(filename, '/')
                       , string.rfind(filename, '\\')
                       , string.rfind(filename, ':') )+1:].strip()
    if not id:
      id_from_file = 1
  else:
    alternative_id = '123'
  filestring = filename.split('\\')
  filename = filestring.pop()
  try:
    ob = context.invokeFactory(id=id, type_name='File')

    #get info about file
    title = filename

    o = getattr(context,id)
    if file is not None:
      o.setFile(file)

    o.edit(
		  id=id,
      title=title
    )
			

  except ConflictError:
    raise

  newID = o.getId()

  uidObj = context.uid_catalog({'id':newID})
  uid = uidObj[0]

  return uid